Description

The version of the SQLite3 gem currently used in Redmine is the outdated 1.7.x. However, when updating to version 2.0.0 or later,

several tests fail due to FrozenError, as shown in the attached details.

diff --git a/Gemfile b/Gemfile

index 71412a11b..229f014af 100644

--- a/Gemfile

+++ b/Gemfile

@@ -75,7 +75,7 @@ if File.exist?(database_file)

       when /postgresql/

         gem 'pg', '~> 1.5.3'

       when /sqlite3/

-        gem 'sqlite3', '~> 1.7.0'

+        gem 'sqlite3', '~> 2.3.0'

       when /sqlserver/

         gem 'tiny_tds', '~> 2.1.2'

         gem 'activerecord-sqlserver-adapter', '~> 7.2.0'

 
$ bin/rails about

About your application's environment

Rails version             7.2.2

Ruby version              ruby 3.3.6 (2024-11-05 revision 75015d4c1f) [arm64-darwin23]

RubyGems version          3.5.22

Rack version              3.1.8

Middleware                ActionDispatch::HostAuthorization, Rack::ContentLength, Rack::Sendfile, 

ActionDispatch::Static, ActionDispatch::Executor, ActiveSupport::Cache::Strategy::LocalCache::Midd

leware, Rack::Runtime, Rack::MethodOverride, ActionDispatch::RequestId, ActionDispatch::RemoteIp, 

Rails::Rack::Logger, ActionDispatch::ShowExceptions, ActionDispatch::DebugExceptions, ActionDispat

ch::ActionableExceptions, ActionDispatch::Reloader, ActionDispatch::Callbacks, ActiveRecord::Migra

tion::CheckPending, ActionDispatch::Cookies, ActionDispatch::Session::CookieStore, ActionDispatch:

:Flash, ActionDispatch::ContentSecurityPolicy::Middleware, ActionDispatch::PermissionsPolicy::Midd

leware, Rack::Head, Rack::ConditionalGet, Rack::ETag, Rack::TempfileReaper

Application root          /Users/maeda/redmines/redmine-trunk

Environment               development

Database adapter          sqlite3

Database schema version   20241103184550

Related issues:

Blocks Redmine - Patch #41865: Update SQLite3 gem to 2.5 Closed

Associated revisions

Revision 23308 - 2024-11-25 07:17 - Go MAEDA

FrozenError when using SQLite3 gem version 2.0.0 or later (#41860).

Patch by Go MAEDA (user:maeda).

Revision 23314 - 2024-11-26 00:38 - Go MAEDA

Merged r23308 from trunk to 6.0-stable (#41860).

History
#1 - 2024-11-25 06:58 - Go MAEDA

- Target version set to 6.0.2

The following patch will fix the issue.

Setting the target version to 6.0.2.

diff --git a/app/models/wiki_content_version.rb b/app/models/wiki_content_version.rb

index 78e056649..79941bf41 100644

--- a/app/models/wiki_content_version.rb

+++ b/app/models/wiki_content_version.rb

@@ -77,20 +77,19 @@ class WikiContentVersion < ApplicationRecord

   def text

     @text ||= begin

       str = case compression

             when 'gzip'

               Zlib::Inflate.inflate(data)

             else

               # uncompressed data

               data

             end

-      str.force_encoding("UTF-8")

-      str

+      (+str).force_encoding('UTF-8')

     end

   end

   def project

     page.project

   end

   def attachments

     page.nil? ? [] : page.attachments

#2 - 2024-11-25 07:04 - Go MAEDA

- Blocks Patch #41865: Update SQLite3 gem to 2.5 added

#3 - 2024-11-25 07:18 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23308.

#4 - 2024-11-26 00:39 - Go MAEDA

- Status changed from Resolved to Closed

Merged the fix into the 6.0-stable branch in r23314.

Files

wiki_content_version_test-errors.txt 1.09 KB 2024-11-25 Go MAEDA

wiki_controller_test-errors.txt 7.63 KB 2024-11-25 Go MAEDA
